class Boat
{
  int x, y;             // Position
  float velX, velY;     // Velocity
  
  boolean landed;       // Whether the ship has landed
  
  float randomValue;    // Holds a random value
  
  Boat()
  {
    landed = false;
    findStart();
    findRoute();
  }  // end of constructor
  
  // Find a route
  
  
  
  void display()
  {
    fill(0,255,255);
    ellipse(x, y, 3, 3);
  }
  
  void move()
  { 
    int loc = x + y * width;
    constrain(loc, 0, tiles.length-1);
    
    // If boat moves off-screen, get rid of it and spawn another boat
    if (x > width || y > height || x < 0 || y < 0)
    {
      if (landed == false)
      {
        boat = new Boat();
      }
    }
    
    // If boat reaches land, settle    
    if (landed == false && tiles[loc].terrainType == 1)
    {
      tiles[loc].terrainType = 4;
      tiles[loc].settlementLevel++;
      for(int i = 0; i < 13; i++)
      {
        PVector spawn = new PVector( x+random(velX*2),y+random(velY*2) );
        people.add(new Person( int(spawn.x), int(spawn.y), x, y) );
      }
      // Move boat off screen
      landed = true;
      x = -1000;
      y = -1000;
      velX = 0;
      velY = 0;
    }
    
    x += velX;
    y += velY;
  }
  
  void findStart()
  {    
    // Find starting position
    randomValue = random(4);
    if (randomValue < 1)
    {
      x = int(random(0, width-1));
      y = 0;
    }
    else if (randomValue < 2)
    {
      x = width-1;
      y = int(random(0, height-1));
    }
    else if (randomValue < 3)
    {
      x = int(random(0, width-1));
      y = height-1;
    }
    else if (randomValue < 4)
    {
      x = 0;
      y = int(random(0, height-1));
    } 
        
    int loc = x + y * width-1;
        
    if (tiles[loc].terrainType == 0)  // If the selected tile is water...
    {
      return;
    }
    else
    {
      findStart();
    }
    
  }  // end of findStart()
  
  
  void findRoute()
  {
    if (randomValue < 1)
    {
      velX = int(random(-4,  4));
      velY = int(random( 1,  3));
    }
    else if (randomValue < 2)
    {
      velX = int(random(-3, -1));
      velY = int(random(-4,  4));
    }
    else if (randomValue < 3)
    {
      velX = int(random(-4,  4));
      velY = int(random(-3, -1));
    }
    else if (randomValue < 4)
    {
      velX = int(random( 1,  3));
      velY = int(random(-4,  4));
    } 
  
    int tempX = x;
    int tempY = y;
    int landCounter = 0;
    
    for (int i = 0; i < height; i++)
    {
      tempX += velX;
      tempY += velY;
      
      int loc = tempX+tempY*width;
      loc = constrain(loc, 0, pixels.length-1);
      
      if (tiles[loc].terrainType == 1)
      {
        landCounter++;
      }
    }
    
    println(landCounter);
    
    if (landCounter >= 10)
    {
      return;
    }
    else
    {
      findRoute();
    }
  
  } // end of findRoute()


}  // end of Class
