// Run through tiles array and check the tile's proximity to other types of tiles...
// then apply the correct values to it.
void analyzeTerrain()
{
  for (int x = 0; x < terrainMap.width/2; x++) {
    for (int y = 0; y < terrainMap.height/2; y++) {  // Use terrainMap width and height as proxy for imaginary "image" of tiles
      
        // Get 1D location of current tile:
        int loc = x + y*(terrainMap.width/2);
        loc = constrain(loc, 0, tiles.length-1);
    
        // Determine this tile's flatness rating
        float flatness = 0;
        // Here's an array to store the flatness ratings compared to each surrounding tile
        float[] flatnessRatings = new float[8];
        // And an index for that array:
        int flatnessRatingsIndex = 0;
        for (int v = 0; v < 3; v++) {
          for (int w = 0; w < 3; w++) {

            // Get the 1D location of the tile we're comparing looked at:
            int compareTileLoc = (tiles[loc].x + (v-1)) + (tiles[loc].y + (w-1))*terrainMap.width;
            compareTileLoc = constrain(compareTileLoc, 0, tiles.length-1);

            // Deal with flatness by comparing this tile's height to all of it's surrounding tiles:
            // Make sure not to count the current tile:
            if (compareTileLoc != loc) {
              flatnessRatings[flatnessRatingsIndex] = determineFlatness(loc, compareTileLoc);
              flatnessRatingsIndex++;
            }

            // Get the average of the flatness ratings for each surrounding tile:
            for (int q = 0; q < flatnessRatings.length; q++) { 
              flatness += flatnessRatings[q];
            } 
            flatness /= (float) flatnessRatings.length;
            tiles[loc].flatness = flatness;
          }
        }
      
    }  // end for y
  }  // end for x
  
}  // end of function
